Index: LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1669)
@@ -33,4 +33,7 @@
   CHARACTER(len=20), dimension(nfiles), private, save   :: type_ecri
   !$OMP THREADPRIVATE(nhorim, nvertm, zoutm,zdtime,type_ecri)
+ ! swaero_diag : flag indicates if it is necessary to do calculation for some aerosol diagnostics
+  logical, save                                :: swaero_diag=.FALSE.
+
 
   !   integer, save                     :: nid_hf3d 
@@ -260,4 +263,24 @@
   type(ctrl_out),save :: o_wape         = ctrl_out((/ 1, 1, 1, 10, 10, 10 /),'wape')
 
+!!! nrlmd le 10/04/2012
+
+!-------Spectre de thermiques de type 2 au LCL
+  type(ctrl_out),save :: o_n2                = ctrl_out((/ 1, 1, 1, 6, 10, 10 /),'n2')
+  type(ctrl_out),save :: o_s2                = ctrl_out((/ 1, 1, 1, 6, 10, 10 /),'s2')
+                                                                             
+!-------Déclenchement stochastique                                           
+  type(ctrl_out),save :: o_proba_notrig      = ctrl_out((/ 1, 1, 1, 6, 10, 10 /),'proba_notrig')
+  type(ctrl_out),save :: o_random_notrig     = ctrl_out((/ 1, 1, 1, 6, 10, 10 /),'random_notrig')
+  type(ctrl_out),save :: o_ale_bl_stat       = ctrl_out((/ 1, 1, 1, 6, 10, 10 /),'ale_bl_stat')
+  type(ctrl_out),save :: o_ale_bl_trig       = ctrl_out((/ 1, 1, 1, 6, 10, 10 /),'ale_bl_trig')
+
+!-------Fermeture statistique
+  type(ctrl_out),save :: o_alp_bl_det        = ctrl_out((/ 1, 1, 1, 10, 10, 10 /),'alp_bl_det')
+  type(ctrl_out),save :: o_alp_bl_fluct_m    = ctrl_out((/ 1, 1, 1, 10, 10, 10 /),'alp_bl_fluct_m')
+  type(ctrl_out),save :: o_alp_bl_fluct_tke  = ctrl_out((/ 1, 1, 1, 10, 10, 10 /),'alp_bl_fluct_tke')
+  type(ctrl_out),save :: o_alp_bl_conv       = ctrl_out((/ 1, 1, 1, 10, 10, 10 /),'alp_bl_conv')
+  type(ctrl_out),save :: o_alp_bl_stat       = ctrl_out((/ 1, 1, 1, 10, 10, 10 /),'alp_bl_stat')
+
+!!! fin nrlmd le 10/04/2012
 
   ! Champs interpolles sur des niveaux de pression ??? a faire correctement
@@ -365,6 +388,8 @@
 
   type(ctrl_out),save :: o_topswad      = ctrl_out((/ 2, 10, 10, 10, 10, 10 /),'topswad')
+  type(ctrl_out),save :: o_topswad0     = ctrl_out((/ 2, 10, 10, 10, 10, 10 /),'topswad0')
   type(ctrl_out),save :: o_topswai      = ctrl_out((/ 2, 10, 10, 10, 10, 10 /),'topswai')
   type(ctrl_out),save :: o_solswad      = ctrl_out((/ 2, 10, 10, 10, 10, 10 /),'solswad')
+  type(ctrl_out),save :: o_solswad0     = ctrl_out((/ 2, 10, 10, 10, 10, 10 /),'solswad0')
   type(ctrl_out),save :: o_solswai      = ctrl_out((/ 2, 10, 10, 10, 10, 10 /),'solswai')
 
@@ -432,4 +457,5 @@
   type(ctrl_out),save :: o_ovap         = ctrl_out((/ 2, 3, 4, 10, 10, 10 /),'ovap')
   type(ctrl_out),save :: o_ovapinit     = ctrl_out((/ 2, 10, 10, 10, 10, 10 /),'ovapinit')
+  type(ctrl_out),save :: o_oliq         = ctrl_out((/ 2, 3, 4, 10, 10, 10 /),'oliq')
   type(ctrl_out),save :: o_wvapp        = ctrl_out((/ 2, 10, 10, 10, 10, 10 /),'wvapp')
   type(ctrl_out),save :: o_geop         = ctrl_out((/ 2, 3, 10, 10, 10, 10 /),'geop')
@@ -494,4 +520,5 @@
   type(ctrl_out),save :: o_dtcon        = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'dtcon')
   type(ctrl_out),save :: o_ducon        = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'ducon')
+  type(ctrl_out),save :: o_dvcon        = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'dvcon')
   type(ctrl_out),save :: o_dqcon        = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'dqcon')
   type(ctrl_out),save :: o_dtwak        = ctrl_out((/ 4, 5, 10, 10, 10, 10 /),'dtwak')
@@ -531,5 +558,4 @@
   type(ctrl_out),save :: o_e_th         = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'e_th')
   type(ctrl_out),save :: o_w_th         = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'w_th')
-  type(ctrl_out),save :: o_lambda_th    = ctrl_out((/ 10, 10, 10, 10, 10, 10 /),'lambda_th')
   type(ctrl_out),save :: o_ftime_th     = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'ftime_th')
   type(ctrl_out),save :: o_q_th         = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'q_th')
@@ -537,5 +563,5 @@
   type(ctrl_out),save :: o_d_th         = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'d_th')
   type(ctrl_out),save :: o_f0_th        = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'f0_th')
-  type(ctrl_out),save :: o_zmax_th      = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'zmax_th')
+  type(ctrl_out),save :: o_zmax_th      = ctrl_out((/ 4,  4,  4,  5, 10, 10 /),'zmax_th')
   type(ctrl_out),save :: o_dqthe        = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'dqthe')
   type(ctrl_out),save :: o_dtajs        = ctrl_out((/ 4, 10, 10, 10, 10, 10 /),'dtajs')
@@ -621,4 +647,5 @@
     USE infotrac
     USE ioipsl
+!    USE phys_cal_mod, only : hour
     USE mod_phys_lmdz_para
     USE aero_mod, only : naero_spc,name_aero
@@ -682,9 +709,9 @@
     !                 entre [phys_out_lonmin,phys_out_lonmax] et [phys_out_latmin,phys_out_latmax]
 
-    logical, dimension(nfiles), save  :: phys_out_regfkey       = (/ .false., .false., .false., .false., .false., .false. /)
-    real, dimension(nfiles), save     :: phys_out_lonmin        = (/ -180., -180., -180., -180., -180., -180. /)
-    real, dimension(nfiles), save     :: phys_out_lonmax        = (/ 180., 180., 180., 180., 180., 180. /)
-    real, dimension(nfiles), save     :: phys_out_latmin        = (/ -90., -90., -90., -90., -90., -90. /)
-    real, dimension(nfiles), save     :: phys_out_latmax        = (/ 90., 90., 90., 90., 90., 90. /)
+    logical, dimension(nfiles), save  :: phys_out_regfkey       = (/ .false., .false., .false.,  .false., .false., .false. /)
+    real, dimension(nfiles), save     :: phys_out_lonmin        = (/   -180.,   -180.,   -180.,    -180.,   -180.,   -180. /)
+    real, dimension(nfiles), save     :: phys_out_lonmax        = (/    180.,    180.,    180.,     180.,    180.,    180. /)
+    real, dimension(nfiles), save     :: phys_out_latmin        = (/    -90.,    -90.,    -90.,     -90.,    -90.,    -90. /)
+    real, dimension(nfiles), save     :: phys_out_latmax        = (/     90.,     90.,     90.,     90.,     90.,     90. /)
 
     write(lunout,*) 'Debut phys_output_mod.F90'
@@ -792,18 +819,22 @@
     DO iff=1,nfiles
 
+       ! Calculate ecrit_files for all files
+       if ( chtimestep(iff).eq.'DefFreq' ) then
+          ! Par defaut ecrit_files = (ecrit_mensuel ecrit_jour ecrit_hf ...)*86400.
+          ecrit_files(iff)=ecrit_files(iff)*86400.
+       else
+          call convers_timesteps(chtimestep(iff),dtime,ecrit_files(iff)) 
+       endif
+       write(lunout,*)'ecrit_files(',iff,')= ',ecrit_files(iff)
+
+       zoutm(iff) = ecrit_files(iff) ! Frequence ou l on ecrit en seconde
+
        IF (clef_files(iff)) THEN
 
-          if ( chtimestep(iff).eq.'DefFreq' ) then
-             ! Par defaut ecrit_files = (ecrit_mensuel ecrit_jour ecrit_hf ...)*86400.
-             ecrit_files(iff)=ecrit_files(iff)*86400.
-          else
-             call convers_timesteps(chtimestep(iff),dtime,ecrit_files(iff)) 
-          endif
-          write(lunout,*)'ecrit_files(',iff,')= ',ecrit_files(iff)
-
-          zoutm(iff) = ecrit_files(iff) ! Frequence ou l on ecrit en seconde
-
           idayref = day_ref
-          CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
+          CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)       
+! correction pour l heure initiale                               !jyg 
+!                                                                !jyg 
+!      CALL ymds2ju(annee_ref, 1, idayref, hour, zjulian)         !jyg
 
 !!!!!!!!!!!!!!!!! Traitement dans le cas ou l'on veut stocker sur un domaine limite !!
@@ -1099,5 +1130,9 @@
                   o_topswad%flag,o_topswad%name, "ADE at TOA", "W/m2")
              CALL histdef2d(iff,clef_stations(iff), &
+                  o_topswad0%flag,o_topswad0%name, "ADE clear-sky at TOA", "W/m2")
+             CALL histdef2d(iff,clef_stations(iff), &
                   o_solswad%flag,o_solswad%name, "ADE at SRF", "W/m2")
+             CALL histdef2d(iff,clef_stations(iff), &
+                  o_solswad0%flag,o_solswad0%name, "ADE clear-sky at SRF", "W/m2")
 
              CALL histdef2d(iff,clef_stations(iff), &
@@ -1216,6 +1251,4 @@
                      o_wbeff%flag,o_wbeff%name, "Conv. updraft velocity at LFC (<100)", "m/s")
              end if
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_prw%flag,o_prw%name, "Precipitable water", "kg/m2")
              IF (.NOT.clef_stations(iff)) THEN 
                 !
@@ -1253,4 +1286,6 @@
           ENDIF !iflag_con .GE. 3
 
+          CALL histdef2d(iff,clef_stations(iff), &
+               o_prw%flag,o_prw%name, "Precipitable water", "kg/m2")
           CALL histdef2d(iff,clef_stations(iff), &
                o_s_pblh%flag,o_s_pblh%name, "Boundary Layer Height", "m")
@@ -1318,8 +1353,10 @@
           ! Couplage conv-CL
           IF (iflag_con.GE.3) THEN
+             IF (iflag_coupl>=1) THEN
                 CALL histdef2d(iff,clef_stations(iff), &
                      o_ale_bl%flag,o_ale_bl%name, "ALE BL", "m2/s2") 
                 CALL histdef2d(iff,clef_stations(iff), &
                      o_alp_bl%flag,o_alp_bl%name, "ALP BL", "m2/s2") 
+             ENDIF
           ENDIF !(iflag_con.GE.3)
 
@@ -1375,4 +1412,5 @@
           CALL histdef3d(iff,clef_stations(iff),o_theta%flag,o_theta%name, "Potential air temperature", "K" )
           CALL histdef3d(iff,clef_stations(iff),o_ovap%flag,o_ovap%name, "Specific humidity", "kg/kg" )
+          CALL histdef3d(iff,clef_stations(iff),o_oliq%flag,o_oliq%name, "Condensed water", "kg/kg" )
           CALL histdef3d(iff,clef_stations(iff), &
                o_ovapinit%flag,o_ovapinit%name, "Specific humidity (begin of timestep)", "kg/kg" )
@@ -1480,4 +1518,6 @@
                o_ducon%flag,o_ducon%name, "Convection du", "m/s2")
           CALL histdef3d(iff,clef_stations(iff), &
+               o_dvcon%flag,o_dvcon%name, "Convection dv", "m/s2")
+          CALL histdef3d(iff,clef_stations(iff), &
                o_dqcon%flag,o_dqcon%name, "Convection dQ", "(kg/kg)/s")
 
@@ -1489,4 +1529,10 @@
                 CALL histdef2d(iff,clef_stations(iff), &
                      o_alp_wk%flag,o_alp_wk%name, "ALP WK", "m2/s2")
+                CALL histdef2d(iff,clef_stations(iff), &
+                     o_ale%flag,o_ale%name, "ALE", "m2/s2")
+                CALL histdef2d(iff,clef_stations(iff), &
+                     o_alp%flag,o_alp%name, "ALP", "W/m2")
+                CALL histdef2d(iff,clef_stations(iff),o_cin%flag,o_cin%name, "Convective INhibition", "m2/s2")
+                CALL histdef2d(iff,clef_stations(iff),o_wape%flag,o_WAPE%name, "WAPE", "m2/s2")
                 CALL histdef2d(iff,clef_stations(iff),o_wake_h%flag,o_wake_h%name, "wake_h", "-")
                 CALL histdef2d(iff,clef_stations(iff),o_wake_s%flag,o_wake_s%name, "wake_s", "-")
@@ -1496,15 +1542,31 @@
                 CALL histdef3d(iff,clef_stations(iff),o_wake_deltaq%flag,o_wake_deltaq%name, "wake_deltaq", " ")
                 CALL histdef3d(iff,clef_stations(iff),o_wake_omg%flag,o_wake_omg%name, "wake_omg", " ")
-                CALL histdef2d(iff,clef_stations(iff),o_wape%flag,o_WAPE%name, "WAPE", "m2/s2")
              ENDIF
-             CALL histdef2d(iff,clef_stations(iff), &
-                     o_ale%flag,o_ale%name, "ALE", "m2/s2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                     o_alp%flag,o_alp%name, "ALP", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff),o_cin%flag,o_cin%name, "Convective INhibition", "m2/s2")
              CALL histdef3d(iff,clef_stations(iff),o_Vprecip%flag,o_Vprecip%name, "precipitation vertical profile", "-")
              CALL histdef3d(iff,clef_stations(iff),o_ftd%flag,o_ftd%name, "tend temp due aux descentes precip", "-")
              CALL histdef3d(iff,clef_stations(iff),o_fqd%flag,o_fqd%name,"tend vap eau due aux descentes precip", "-")
           ENDIF !(iflag_con.EQ.3)
+
+!!! nrlmd le 10/04/2012
+
+        IF (iflag_trig_bl>=1) THEN
+ CALL histdef2d(iff,clef_stations(iff),o_n2%flag,o_n2%name, "Nombre de panaches de type 2", " ")
+ CALL histdef2d(iff,clef_stations(iff),o_s2%flag,o_s2%name, "Surface moyenne des panaches de type 2", "m2")
+
+ CALL histdef2d(iff,clef_stations(iff),o_proba_notrig%flag,o_proba_notrig%name, "Probabilité de non-déclenchement", " ")
+ CALL histdef2d(iff,clef_stations(iff),o_random_notrig%flag,o_random_notrig%name, "Tirage aléatoire de non-déclenchement", " ")
+ CALL histdef2d(iff,clef_stations(iff),o_ale_bl_trig%flag,o_ale_bl_trig%name, "ALE_BL_STAT + Condition P>Pseuil", "m2/s2")
+ CALL histdef2d(iff,clef_stations(iff),o_ale_bl_stat%flag,o_ale_bl_stat%name, "ALE_BL_STAT", "m2/s2")
+       ENDIF  !(iflag_trig_bl>=1)
+
+        IF (iflag_clos_bl>=1) THEN
+ CALL histdef2d(iff,clef_stations(iff),o_alp_bl_det%flag,o_alp_bl_det%name, "ALP_BL_DET", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff),o_alp_bl_fluct_m%flag,o_alp_bl_fluct_m%name, "ALP_BL_FLUCT_M", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff),o_alp_bl_fluct_tke%flag,o_alp_bl_fluct_tke%name, "ALP_BL_FLUCT_TKE", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff),o_alp_bl_conv%flag,o_alp_bl_conv%name, "ALP_BL_CONV", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff),o_alp_bl_stat%flag,o_alp_bl_stat%name, "ALP_BL_STAT", "W/m2")
+       ENDIF  !(iflag_clos_bl>=1)
+
+!!! fin nrlmd le 10/04/2012
 
           CALL histdef3d(iff,clef_stations(iff),o_dtlsc%flag,o_dtlsc%name, "Condensation dT", "K/s")
@@ -1519,5 +1581,5 @@
           CALL histdef3d(iff,clef_stations(iff),o_dtthe%flag,o_dtthe%name, "Thermal dT", "K/s")
 
-          if(iflag_thermals.gt.1) THEN
+          if(iflag_thermals.ge.1) THEN
              CALL histdef3d(iff,clef_stations(iff),o_dqlscth%flag,o_dqlscth%name, "dQ therm.", "(kg/kg)/s")
              CALL histdef3d(iff,clef_stations(iff),o_dqlscst%flag,o_dqlscst%name, "dQ strat.", "(kg/kg)/s")
@@ -1531,6 +1593,4 @@
              CALL histdef3d(iff,clef_stations(iff),o_e_th%flag,o_e_th%name,"Thermal plume entrainment","K/s")
              CALL histdef3d(iff,clef_stations(iff),o_w_th%flag,o_w_th%name,"Thermal plume vertical velocity","m/s")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_lambda_th%flag,o_lambda_th%name,"Thermal plume vertical velocity","m/s")
              CALL histdef2d(iff,clef_stations(iff), &
                   o_ftime_th%flag,o_ftime_th%name,"Fraction of time Shallow convection occurs"," ")
@@ -1548,5 +1608,5 @@
              CALL histdef3d(iff,clef_stations(iff), &
                   o_dqthe%flag,o_dqthe%name, "Thermal dQ", "(kg/kg)/s")
-          endif !iflag_thermals.gt.1
+          endif !iflag_thermals.ge.1
           CALL histdef3d(iff,clef_stations(iff), &
                o_dtajs%flag,o_dtajs%name, "Dry adjust. dT", "K/s")
@@ -1708,4 +1768,15 @@
 
     ENDDO !  iff
+
+    ! Updated write frequencies due to phys_out_filetimesteps. 
+    ! Write frequencies are now in seconds.  
+    ecrit_mth = ecrit_files(1)
+    ecrit_day = ecrit_files(2)
+    ecrit_hf  = ecrit_files(3)
+    ecrit_ins = ecrit_files(4)
+    ecrit_LES = ecrit_files(5)
+    ecrit_ins = ecrit_files(6)
+
+    write(lunout,*)'swaero_diag=',swaero_diag
     write(lunout,*)'Fin phys_output_mod.F90'
   end subroutine phys_output_open
@@ -1756,4 +1827,11 @@
        endif
     endif
+
+    ! Set swaero_diag=true if at least one of the concerned variables are defined 
+    if (nomvar=='topswad' .OR. nomvar=='topswai' .OR. nomvar=='solswad' .OR. nomvar=='solswai' ) THEN
+       if  ( flag_var(iff)<=lev_files(iff) ) then
+          swaero_diag=.TRUE.
+       end if
+    end if
   end subroutine histdef2d
 
Index: LMDZ5/branches/testing/libf/phylmd/phys_output_write.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_write.h	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_write.h	(revision 1669)
@@ -508,5 +508,5 @@
         ENDIF
 
-       if (iflag_pbl>1 .and. lev_histday.gt.10 ) then
+       if (iflag_pbl>1 .and. lev_files(iff).gt.10 ) then
         IF (o_tke_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
@@ -631,9 +631,4 @@
         end if
 
-        IF (o_prw%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_prw%name,itau_w,prw)
-        ENDIF
-
       IF (.NOT.clef_stations(iff)) THEN
       IF (o_cape_max%flag(iff)<=lev_files(iff)) THEN
@@ -671,5 +666,5 @@
 
        IF (o_mc%flag(iff)<=lev_files(iff)) THEN
-        if(iflag_thermals.gt.1)then
+        if(iflag_thermals>=1)then
          zx_tmp_fi3d=dnwd+dnwd0+upwd+fm_therm(:,1:klev)
         else
@@ -681,4 +676,9 @@
       
       ENDIF !iflag_con .GE. 3
+
+        IF (o_prw%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_prw%name,itau_w,prw)
+        ENDIF
 
         IF (o_s_pblh%flag(iff)<=lev_files(iff)) THEN
@@ -801,4 +801,5 @@
 ! Couplage convection-couche limite
       IF (iflag_con.GE.3) THEN
+      IF (iflag_coupl>=1) THEN
        IF (o_ale_bl%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
@@ -809,4 +810,5 @@
      $o_alp_bl%name,itau_w,alp_bl)
        ENDIF
+      ENDIF !iflag_coupl>=1
       ENDIF !(iflag_con.GE.3)
 
@@ -823,4 +825,16 @@
        ENDIF
 
+       IF (o_ale%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ale%name,itau_w,ale)
+       ENDIF
+       IF (o_alp%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_alp%name,itau_w,alp)
+       ENDIF
+       IF (o_cin%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_cin%name,itau_w,cin)
+       ENDIF
        IF (o_wape%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
@@ -869,16 +883,4 @@
       ENDIF ! iflag_wake>=1
 
-       IF (o_ale%flag(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_ale%name,itau_w,ale)
-       ENDIF
-       IF (o_alp%flag(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_alp%name,itau_w,alp)
-       ENDIF
-       IF (o_cin%flag(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_cin%name,itau_w,cin)
-       ENDIF
         IF (o_Vprecip%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
@@ -897,4 +899,67 @@
       ENDIF !(iflag_con.EQ.3) 
  
+!!! nrlmd le 10/04/2012
+
+        IF (iflag_trig_bl>=1) THEN
+          IF (o_n2%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_n2%name,itau_w,n2)
+         ENDIF
+
+         IF (o_s2%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_s2%name,itau_w,s2)
+         ENDIF
+
+          IF (o_proba_notrig%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_proba_notrig%name,itau_w,proba_notrig)
+         ENDIF
+
+         IF (o_random_notrig%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_random_notrig%name,itau_w,random_notrig)
+         ENDIF
+
+         IF (o_ale_bl_stat%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_ale_bl_stat%name,itau_w,ale_bl_stat)
+         ENDIF
+
+         IF (o_ale_bl_trig%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_ale_bl_trig%name,itau_w,ale_bl_trig)
+         ENDIF
+       ENDIF  !(iflag_trig_bl>=1)
+
+        IF (iflag_clos_bl>=1) THEN
+         IF (o_alp_bl_det%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_alp_bl_det%name,itau_w,alp_bl_det)
+         ENDIF
+
+         IF (o_alp_bl_fluct_m%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_alp_bl_fluct_m%name,itau_w,alp_bl_fluct_m)
+         ENDIF
+
+         IF (o_alp_bl_fluct_tke%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                o_alp_bl_fluct_tke%name,itau_w,alp_bl_fluct_tke)
+         ENDIF
+
+         IF (o_alp_bl_conv%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_alp_bl_conv%name,itau_w,alp_bl_conv)
+         ENDIF
+
+         IF (o_alp_bl_stat%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     s                     o_alp_bl_stat%name,itau_w,alp_bl_stat)
+         ENDIF
+       ENDIF  !(iflag_clos_bl>=1)
+
+!!! fin nrlmd le 10/04/2012
+
       IF (type_ocean=='slab ') THEN
       IF ( o_slab_bils%flag(iff)<=lev_files(iff)) 
@@ -1193,4 +1258,10 @@
      $            topswad_aero)
           ENDIF
+          IF (o_topswad0%flag(iff)<=lev_files(iff)) THEN
+             CALL histwrite_phy(nid_files(iff),
+     $clef_stations(iff),
+     $o_topswad0%name,itau_w,
+     $            topswad0_aero)
+          ENDIF
           IF (o_solswad%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
@@ -1198,4 +1269,10 @@
      $o_solswad%name,itau_w,
      $            solswad_aero)
+          ENDIF
+          IF (o_solswad0%flag(iff)<=lev_files(iff)) THEN
+             CALL histwrite_phy(nid_files(iff),
+     $clef_stations(iff),
+     $o_solswad0%name,itau_w,
+     $            solswad0_aero)
           ENDIF
 
@@ -1410,4 +1487,9 @@
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      $                   o_ovap%name,itau_w,q_seri)
+       ENDIF
+                                                               
+       IF (o_oliq%flag(iff)<=lev_files(iff)) THEN              
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),    
+     $                   o_oliq%name,itau_w,ql_seri)            
        ENDIF
 
@@ -1637,4 +1719,10 @@
        ENDIF
 
+       IF (o_dvcon%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_v_con(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dvcon%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
        IF (o_dqcon%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_con(1:klon,1:klev)/pdtphys
@@ -1680,5 +1768,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 ! Sorties specifiques a la separation thermiques/non thermiques
-       if (iflag_thermals>1) then
+       if (iflag_thermals>=1) then
 
        IF (o_dtlscth%flag(iff)<=lev_files(iff)) THEN
@@ -1744,5 +1832,5 @@
        ENDIF
 
-      endif ! iflag_thermals>1
+      endif ! iflag_thermals>=1
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -1791,5 +1879,5 @@
        ENDIF
 
-       IF (iflag_thermals.gt.1) THEN
+       IF (iflag_thermals>=1) THEN
         IF (o_ftime_th%flag(iff)<=lev_files(iff)) THEN
 ! Pour l instant 0 a y reflichir pour les thermiques
@@ -1820,8 +1908,4 @@
         ENDIF
 
-        IF (o_lambda_th%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     s                     o_lambda_th%name,itau_w,lambda_th)
-        ENDIF
 
         IF (o_a_th%flag(iff)<=lev_files(iff)) THEN
@@ -2051,17 +2135,29 @@
        ENDIF
 
-       IF (o_mcd%flag(iff)<=lev_files(iff)) THEN
-      zx_tmp_fi3d(1:klon,1:klev)=-1 * (dnwd(1:klon,1:klev)+
-     $                                 dnwd0(1:klon,1:klev)) 
-      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_mcd%name,itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (o_dmc%flag(iff)<=lev_files(iff)) THEN
-      zx_tmp_fi3d(1:klon,1:klev)=upwd(1:klon,1:klev) +
-     $  dnwd(1:klon,1:klev)+ dnwd0(1:klon,1:klev) 
-      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
-     $o_dmc%name,itau_w,zx_tmp_fi3d)
-       ENDIF
+       if (iflag_con >= 3) then
+          IF (o_mcd%flag(iff)<=lev_files(iff)) THEN
+             zx_tmp_fi3d(1:klon,1:klev)=-1 * (dnwd(1:klon,1:klev)+
+     $            dnwd0(1:klon,1:klev)) 
+             CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $            o_mcd%name,itau_w,zx_tmp_fi3d)
+          ENDIF
+
+          IF (o_dmc%flag(iff)<=lev_files(iff)) THEN
+             zx_tmp_fi3d(1:klon,1:klev)=upwd(1:klon,1:klev) +
+     $            dnwd(1:klon,1:klev)+ dnwd0(1:klon,1:klev) 
+             CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $            o_dmc%name,itau_w,zx_tmp_fi3d)
+          ENDIF
+       else if (iflag_con == 2) then
+          IF (o_mcd%flag(iff) <= lev_files(iff)) THEN
+             CALL histwrite_phy(nid_files(iff), clef_stations(iff),
+     $            o_mcd%name, itau_w, pmfd)
+          ENDIF
+
+          IF (o_dmc%flag(iff) <= lev_files(iff)) THEN
+             CALL histwrite_phy(nid_files(iff), clef_stations(iff),
+     $            o_dmc%name, itau_w, pmfu + pmfd)
+          ENDIF
+       end if
 
        IF (o_ref_liq%flag(iff)<=lev_files(iff)) THEN
Index: LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 1669)
@@ -346,4 +346,9 @@
 !$OMP THREADPRIVATE(ccm)
 
+!!! nrlmd le 10/04/2012
+      REAL,SAVE,ALLOCATABLE :: ale_bl_trig(:)
+!$OMP THREADPRIVATE(ale_bl_trig)
+!!! fin nrlmd le 10/04/2012
+
 CONTAINS
 
@@ -496,4 +501,8 @@
       ALLOCATE(tau_aero(klon,klev,naero_grp,nbands),piz_aero(klon,klev,naero_grp,nbands),cg_aero(klon,klev,naero_grp,nbands))
       ALLOCATE(ccm(klon,klev,nbands))
+
+!!! nrlmd le 10/04/2012
+      ALLOCATE(ale_bl_trig(klon))
+!!! fin nrlmd le 10/04/2012
 
 END SUBROUTINE phys_state_var_init
@@ -603,4 +612,8 @@
       deallocate(ccm)
        
+!!! nrlmd le 10/04/2012
+      deallocate(ale_bl_trig)
+!!! fin nrlmd le 10/04/2012
+
 END SUBROUTINE phys_state_var_end
 
